#include <stdio.h>
#include <string.h>
#include "lib.h"
#include "internet.h"	   	// header file of the TCP/IP library

struct dns_config dns; // Declares structure which contains DNS configurations
struct isp_config isp;	// Declares structure which contains ISP configurations

void main (void)
{
	int error=0;

	systemsetting ("SZ");		// COM speed set to 115200 baud
	cursor(NOWRAP);

	// 2: Display progress messages and a progress bar
	// 0: Turn off the debug status messages
	TCPIP_init(2, 0);

	// Internet Service Provider Settings
	strcpy((char *)isp.phonenumber, "0031555012345");	// change this value!
	strcpy((char *)isp.user, "user");					// change this value!
	strcpy((char *)isp.pass, "password");				// change this value!

	isp.com	= COM2;										// Connect modem to cradle
	isp.abort_key = CLR_KEY;

	dns.abort_key = CLR_KEY;

	for(;;)
	{
		if( (error = connect(&isp)) < 0 )				// Dial ISP server
		{
			printf("\nConnect: \nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up
			
			resetkey();

			while(!kbhit())
				idle();

			continue;
		}
		
		strcpy((char *)dns.domain_address, "ftp.aol.com"); 	// change this value!

		if( (error=get_host_by_name(&dns)) < 0)		// Retreive IP-address from DNS-server
		{
			printf("\nHost by name:\nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			resetkey();
			
			while(!kbhit())
				idle();

			continue;
		}

		// Show retrieved IP-address
		printf("\fDomain name:\n%s\n IP ->\n%d.%d.%d.%d", dns.domain_address, dns.IP1, dns.IP2, dns.IP3, dns.IP4);
		
		delay(100);

		// IP-address = 205.188.212.118
		dns.IP1 = 205;									// change this value!
		dns.IP2 = 188;									// change this value!
		dns.IP3 = 212;									// change this value!
		dns.IP4 = 118;									// change this value!

		// Retreive domain name from DNS-server
		if( (error=get_host_by_addr(&dns)) < 0 )
		{
			printf("\nHost by addr:\nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			resetkey();
			
			while(!kbhit())
				idle();

			continue;
		}

		//Show retrieved domain name
		printf("\fIP-address:\n%d.%d.%d.%d\nDomain name:\n%s\n", dns.IP1, dns.IP2, dns.IP3, dns.IP4, dns.domain_address);

		disconnect(&isp);								// Disconnect from ISP and hang-up

		printf("\nPress any key");

		resetkey();

		while(!kbhit())
			idle();
	}
}
