#include <stdio.h>
#include <string.h>
#include "lib.h"
#include "internet.h"	// header file of the TCP/IP library

struct ftp_config ftp;	// Declares structure which contains SMTP configurations
struct isp_config isp;	// Declares structure which contains ISP configurations

void main (void)
{
	int error, key=0;

	setfont(SMALL_FONT, NULL);	// small font
	systemsetting ("SZ");		// COM speed set to 115200 baud
	cursor(NOWRAP);

	// 2: Display progress messages and a progress bar
	// 0: Turn off the debug status messages
	TCPIP_init(2, 0);

	// Internet Service Provider Settings
	strcpy((char *)isp.phonenumber, "0031555012345");	// change this value!
	strcpy((char *)isp.user, "user");					// change this value!
	strcpy((char *)isp.pass, "password");				// change this value!

	isp.com	= COM2;										// Modem is connected to cradle
	isp.abort_key = CLR_KEY;

	// FTP IP-address = 62.58.50.14
	ftp.IP1 = 62;										// change this value!
	ftp.IP2 = 58;										// change this value!
	ftp.IP3 = 50;										// change this value!
	ftp.IP4 = 14;										// change this value!

	strcpy ((char *)ftp.user, "ftp_user");				// change this value!
	strcpy ((char *)ftp.pass, "ftp_pass");				// change this value!

	ftp.append = FALSE;
	ftp.abort_key = CLR_KEY;							// The CLR key will be used to abort

	for(;;)
	{
		printf("\nFTP: choose\n");						// Show 3 FTP options
		printf("1) Put file\n");
		printf("2) Get file\n");
		printf("3) Put&get files\n");

		resetkey();										// Clear keyboard buffer

		while( (key = getchar()) == EOF )				// Wait for key
			idle();

		if( key < '1' || key > '3')						// Check for invalid keys
			continue;

		if( (error = connect(&isp)) < 0 )				// Dial ISP server
		{
			printf("\nConnect: \nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			while(!kbhit())
				idle();

			continue;
		}

		if ( (error=ftp_command(&ftp,FTP_INIT)) < 0)	// Connect and login at FTP server
		{
			printf("\nftp_init: \nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			while(!kbhit())
				idle();

			continue;
		}


		if (key=='1' || key=='3')						// Upload
		{
			strcpy((char *)ftp.local_file, "data.txt");	// Upload file "data.txt"
			strcpy((char *)ftp.remote_file,"data.txt");	// Store file as "data.txt"

			if ( (error=ftp_command(&ftp, FTP_PUT)) < 0)
			{
				printf("\nFTP put: \nerror #%d", error); // Upload file to FTP

				if(ftp_connected())						// Disconnect from FTP server
					ftp_command(&ftp,FTP_QUIT);

				disconnect(&isp);						// Disconnect from ISP and hang-up

				while(!kbhit())
					idle();

				continue;
			}
		}

		if (key=='2' || key=='3')						// Download
		{
			strcpy((char *)ftp.remote_file,"data.txt");	// Download file "data.txt"
			strcpy((char *)ftp.local_file, "data.txt");	// Store file as "data.txt"

			if ( (error=ftp_command(&ftp,FTP_GET)) < 0)	// Download file from FTP
			{
				printf("\nFTP get: \nerror #%d", error);

				if(ftp_connected())						// Disconnect from FTP server
					ftp_command(&ftp,FTP_QUIT);

				disconnect(&isp);						// Disconnect from ISP and hang-up

				while(!kbhit())
					idle();

				continue;
			}
		}

		// disconnect from FTP server
		if(ftp_connected())								// If still connected to FTP
		{
			if ( (error=ftp_command(&ftp,FTP_QUIT)) < 0)// Disconnect from FTP server
			{
				printf("\nFTP quit: \nerror #%d", error);
				disconnect(&isp);						// Disconnect from ISP and hang-up

				while(!kbhit())
					idle();

				continue;
			}
		}

		disconnect(&isp);								// Disconnect from ISP
	}
}
