#include <stdio.h>
#include <string.h>
#include "lib.h"
#include "internet.h"	 	// header file of the TCP/IP library

struct ntp_config ntp; 	// Declares structure which contains NTP configurations
struct isp_config isp;		// Declares structure which contains ISP configurations
struct date d;
struct time t;

void main (void)
{
	int error=0;

	systemsetting ("SZ");		// COM speed set to 115200 baud
	cursor(NOWRAP);

	// Internet Service Provider Settings
	strcpy((char *)isp.phonenumber, "0031555012345");	// change this value!
	strcpy((char *)isp.user, "user");					// change this value!
	strcpy((char *)isp.pass, "password");				// change this value!

	isp.com	= COM2;										// Connect modem to cradle
	isp.abort_key = CLR_KEY;

	ntp.abort_key = CLR_KEY;

	ntp.IP1 = 83;	// IP from nl.pool.ntp.org (83.83.82.105)
	ntp.IP2 = 83;	// IP-addresses can be changed without prior notice
	ntp.IP3 = 82;	// for this reason always use DNS (getHostbyName) to
	ntp.IP4 = 105;	// retrieve the IP-addresses of the used NTP servers

	for(;;)
	{
		// 2: Display progress messages and a progress bar
		// 0: Turn off the debug status messages
		TCPIP_init(2, 0);
		
		printf("\nPress any key");

		resetkey();

		while(!kbhit())
			idle();

		if( (error = connect(&isp)) < 0 )				// Dial ISP server
		{
			printf("\nConnect: \nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			while(!kbhit())
				idle();

			continue;
		}
		
		TCPIP_init(0, 0);
		printf("\f\n Please wait  ");

		gettime(&t);								// Get current local time
		getdate(&d);								// Get current date

		ntp.date = &d;								// Set date & time parameters
		ntp.time = &t;

		if( (error=get_NTP_time(&ntp, +2)) < 0) 	// get time from NTP
		{
			printf("\nget_NTP_time: \nerror #%d", error);
		}
		else
		{
			gotoxy(0,1);
			printf("   %02d:%02d:%02d ",t.ti_hour, t.ti_min, t.ti_sec);
			gotoxy(0,2);
			printf("  %02d-%02d-%04d", d.da_day, d.da_mon, d.da_year);

			setdate(&d);							// Save date & time
			settime(&t);
		}

		disconnect(&isp);								// Disconnect from ISP and hang-up		
	}
}
