#include <stdio.h>
#include <string.h>
#include "lib.h"
#include "internet.h"	   	// header file of the TCP/IP library

struct mail_config mail;	// Declares structure which contains SMTP configurations
struct isp_config isp;	  	// Declares structure which contains ISP configurations

void main (void)
{
	int error=0;
	char* textMessage = "ATTACHMENT INCLUDED";

	setfont(SMALL_FONT, NULL);	// small font
	systemsetting ("SZ");		// COM speed set to 115200 baud
	cursor(NOWRAP);

	// 2: Display progress messages and a progress bar
	// 0: Turn off the debug status messages
	TCPIP_init(2, 0); 	

	// Internet Service Provider Settings
	strcpy((char *)isp.phonenumber, "0031555012345");	// change this value!
	strcpy((char *)isp.user, "user");					// change this value!
	strcpy((char *)isp.pass, "password");				// change this value!

	isp.com	= COM2;										// Connect modem to cradle
	isp.abort_key = CLR_KEY;

	// SMTP IP-address = 194.109.6.51
	mail.IP1 = 194;										// change this value!
	mail.IP2 = 109;										// change this value! 
	mail.IP3 = 6;										// change this value! 
	mail.IP4 = 51;										// change this value!	

	strcpy((char *)mail.sender,	   "your_email@opticon.com");	// change this value!
	strcpy((char *)mail.reply,     "DONOTREPLY@opticon.com");	// change this value!
	strcpy((char *)mail.recipient, "recipient@hotmail.com");	// change this value!

	strcpy((char *)mail.subject, "Test email");			// Subject
	
	strcpy((char *)mail.local_file, "data.txt");		// File that is emailed

	mail.smtp_msg = (char *)textMessage;				// Point to email body

	mail.attach = TRUE;									// Attach file to email (FALSE is include in body)
	
	mail.base64 = TRUE;									// Use base64 encoding to send file as binary data
	
	mail.abort_key = CLR_KEY;

	for(;;)
	{
		printf("\nPress any key");

		resetkey();

		while(!kbhit())
			idle();
		
		if( (error = connect(&isp)) < 0 )				// Dial ISP server
		{
			printf("\nConnect: \nerror #%i", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up
			
			while(!kbhit())
				idle();

			continue;
		}

		if ( (error=sendmail(&mail)) < 0 )
		{
			printf("\nsendmail: \nerror #%i", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			while(!kbhit())
				idle();

			continue;
		}

		disconnect(&isp);								// Disconnect from ISP

		printf("\nEmail sent\n");
	}
}
