
#define NONE   -1		// No software found
#define CURRENT	0		// Current version found
#define LOWER	1		// Lower version found
#define HIGHER	2		// Higher version found

/**************************************************************************************/
/* CheckForUpdates                                                                    */
/**************************************************************************************/
/* Description                                                                        */
/*   Searches for a software update in a file with an FTP directory listing           */
/*                                                                                    */
/* Input                                                                              */
/*   char *fname_dir :  File name with FTP directory listing                          */
/*   char *version   :  Current 5 char version string (without software code)         */
/*                       (i.e. 4000A if the software version is CFX4000A)             */
/*                                                                                    */
/* Output                                                                             */
/*   char *fresult   :  If present,filename of latest version found in the directory  */
/*                       (Mininum size of string: 13)                                 */
/* Returns                                                                            */
/*   NONE   (-1)     :   No software versions found at all                            */
/*   SAME	(0)      :   Software is up to date                                       */
/*   LOWER	(1)      :   Lower software version found                                 */
/*   HIGHER	(2)      :   Higher software version found                                */
/**************************************************************************************/
extern int CheckForUpdates(const char *fname_dir, const char *version, char *fresult);
