
#define ID_UPC 			0x0001
#define ID_EAN 			0x0002
#define ID_CODE39		0x0004
#define ID_CODABAR		0x0008
#define ID_D2OF5    	0x0010
#define ID_I2OF5		0x0020
#define ID_IATA			0x0040
#define ID_CODE93		0x0080
#define ID_CODE128		0x0100
#define ID_MSI_PLESSEY 	0x0200
#define ID_ADDONS		0x0400
#define ID_UK_PLESSEY	0x0800
#define	ID_TELEPEN		0x1000
#define	ID_M2OF5        0x2000
#define	ID_SCODE        0x4000

const char back_string[]		= "(back)";
const char jan13_string[] 		= "JAN 13";
const char ean13_string[] 		= "EAN 13";
const char upca_string[] 		= "UPC A";
const char jan8_string[] 		= "JAN 8";
const char ean8_string[] 		= "EAN 8";
const char upce_string[] 		= "UPC E";
const char instore13_string[] 	= "INSTORE 13";
const char instore8_string[] 	= "INSTORE 8";
const char code39_string[] 		= "CODE 39";
const char codabar_string[] 	= "CODABAR";

const char d2of5_string[] 		= "INDUST 2 OF 5";
const char i2of5_string[] 		= "INTERL 2 OF 5";
const char code93_string[] 		= "CODE 93";
const char code128_string[] 	= "CODE 128";
const char msi_string[] 		= "MSI PLESSEY";
const char iata_string[] 		= "IATA";
const char uk_string[] 			= "UK PLESSEY";
const char telepen_string[] 	= "TELEPEN";
const char m2of5_string[] 		= "MATRIX 2 OF 5";
const char chinpost_string[] 	= "CHINESE POST";
const char nw7_abc_string[] 	= "CODABAR ABC";
const char nw7_cx_string[] 		= "CODABAR CX";
const char scode_string[] 		= "SCODE";
const char laetus_string[] 		= "LAETUS";
const char c39_fa_string[] 		= "CD 39 FULL ASCII";
const char c39_it_string[] 		= "ITALIAN PHARMA.";
const char unknown_string[] 	= "UNKNOWN CODE";
const char all_addon_string[]	= "All ADDONS";
const char ean_string[]			= "EAN";
const char upc_string[]			= "UPC";

const char jan13_2_string[]		= "JAN 13 + 2";
const char ean13_2_string[]		= "EAN 13 + 2";
const char upca_2_string[]		= "UPC A + 2";
const char jan8_2_string[]		= "JAN 8 + 2";
const char ean8_2_string[]		= "EAN 8 + 2";
const char upce_2_string[]		= "UPC E + 2";
const char code128_2_string[]	= "CODE 128 + 2";

const char jan13_5_string[]		= "JAN 13 + 5";
const char ean13_5_string[]		= "EAN 13 + 5";
const char upca_5_string[]		= "UPC A + 5";
const char jan8_5_string[]		= "JAN 8 + 5";
const char ean8_5_string[]		= "EAN 8 + 5";
const char upce_5_string[]		= "UPC E + 5";
const char code128_5_string[]	= "CODE 128 + 5";

const char menu_string[]		= "MENU CODE";

#define OFF_ADDON_2 	26
#define OFF_ADDON_2_128	32
#define OFF_ADDON_5 	33
#define OFF_ADDON_5_128	39
#define OFF_MNU_CDE		40

const struct smenus symblglist[] =
{                                 			/* index position */
	(char*)jan13_string, 	 	JAN13, 		/*  0 */
	(char*)ean13_string, 		EAN13,		/*  1 */
	(char*)upca_string,    		UPCA,		/*  2 */
	(char*)jan8_string, 		JAN8,		/*  3 */
	(char*)ean8_string, 		EAN8,		/*  4 */
	(char*)upce_string, 		UPCE,		/*  5 */
	(char*)instore13_string,   	INSTORE13,	/*  6 */
	(char*)instore8_string,		INSTORE8,	/*  7 */
	(char*)code39_string, 		CODE39,		/*  8 */
	(char*)codabar_string, 		CODABAR,	/*  9 */
	(char*)d2of5_string,		D2OF5,		/* 10 */
	(char*)i2of5_string,		I2OF5,		/* 11 */
	(char*)code93_string, 		CODE93,		/* 12 */
	(char*)code128_string,     	CODE128,	/* 13 */
	(char*)msi_string, 			MSI_PLESSEY,/* 14 */
	(char*)iata_string,			IATA,		/* 15 */
	(char*)uk_string,			UK_PLESSEY, /* 16 */
	(char*)telepen_string, 		TELEPEN,	/* 17 */
	(char*)m2of5_string,		M2OF5,		/* 18 */
	(char*)chinpost_string, 	CHINPOST,	/* 19 */
	(char*)nw7_abc_string,  	NW7_ABC,	/* 20 */
	(char*)nw7_cx_string,   	NW7_CX,		/* 21 */
	(char*)scode_string,   		SCODE,		/* 22 */
	(char*)laetus_string,  		LAETUS,		/* 23 */
	(char*)c39_fa_string, 		C39_FA,		/* 24 */
	(char*)c39_it_string, 		C39_IT,		/* 25 */
	(char*)jan13_2_string,      JAN13_2,	/* 0 + OFF_ADDON_2 */
	(char*)ean13_2_string,		EAN13_2,	/* 1 + OFF_ADDON_2 */
	(char*)upca_2_string,		UPCA_2,     /* 2 + OFF_ADDON_2 */
	(char*)jan8_2_string,		JAN8_2,     /* 3 + OFF_ADDON_2 */
	(char*)ean8_2_string,		EAN8_2,     /* 4 + OFF_ADDON_2 */
	(char*)upce_2_string,		UPCE_2,     /* 5 + OFF_ADDON_2 */
	(char*)code128_2_string,	CODE128_2,  /* OFF_ADDON_2_128 */
	(char*)jan13_5_string,		JAN13_5,    /* 0 + OFF_ADDON_5 */
	(char*)ean13_5_string,		EAN13_5,    /* 1 + OFF_ADDON_5 */
	(char*)upca_5_string,		UPCA_5,     /* 2 + OFF_ADDON_5 */
	(char*)jan8_5_string,		JAN8_5,     /* 3 + OFF_ADDON_5 */
	(char*)ean8_5_string,		EAN8_5,     /* 4 + OFF_ADDON_5 */
	(char*)upce_5_string,		UPCE_5,     /* 5 + OFF_ADDON_5 */
	(char*)code128_5_string,	CODE128_5,  /* OFF_ADDON_5_128 */
	(char*)menu_string,			MENU_CODE,  /* OFF_MNU_CDE 	   */
	(char*)unknown_string ,   	-1
};


const struct smenus barcodem[] =
{
	(char*)back_string, 		-1,
	(char*)upc_string,    		ID_UPC,
	(char*)ean_string, 			ID_EAN,
	(char*)code39_string, 		ID_CODE39,
	(char*)codabar_string, 		ID_CODABAR,
	(char*)d2of5_string,		ID_D2OF5,
	(char*)i2of5_string,		ID_I2OF5,
	(char*)iata_string,			ID_IATA,
	(char*)code93_string, 		ID_CODE93,
	(char*)code128_string,  	ID_CODE128,
	(char*)msi_string, 			ID_MSI_PLESSEY,
	(char*)uk_string, 			ID_UK_PLESSEY,
	(char*)telepen_string,		ID_TELEPEN,
	(char*)m2of5_string, 		ID_M2OF5,
	(char*)scode_string, 		ID_SCODE,
	(char*)all_addon_string,    ID_ADDONS
};


const char day_gb_sunday[] 		= "  Sunday  ";
const char day_gb_monday[] 		= "  Monday  ";
const char day_gb_tuesday[]		= "  Tuesday ";
const char day_gb_wednesday[] 	= " Wednesday";
const char day_gb_thursday[]	= " Thursday ";
const char day_gb_friday[]		= "  Friday  ";
const char day_gb_saturday[]  	= " Saturday ";

const struct menus day_gb[] = {	(char*)day_gb_sunday,
								(char*)day_gb_monday,
								(char*)day_gb_tuesday,
								(char*)day_gb_wednesday,
								(char*)day_gb_thursday,
								(char*)day_gb_friday,
								(char*)day_gb_saturday };

#define ID_115200	1
#define ID_57600    2
#define ID_38400    3
#define ID_19200    4
#define ID_9600     5
#define ID_4800     6
#define ID_2400     7


const char baud_115200[] 	= "115200 Baud";
const char baud_57600[] 	= " 57600 Baud";
const char baud_38400[] 	= " 38400 Baud";
const char baud_19200[] 	= " 19200 Baud";
const char baud_9600[] 		= "  9600 Baud";
const char baud_4800[] 		= "  4800 Baud";
const char baud_2400[] 		= "  2400 Baud";


const struct smenus baudm[] = { (char*)back_string,	-1,
								(char*)baud_115200, ID_115200,
								(char*)baud_57600, 	ID_57600,
								(char*)baud_38400, 	ID_38400,
								(char*)baud_19200, 	ID_19200,
								(char*)baud_9600, 	ID_9600,
								(char*)baud_4800, 	ID_4800,
								(char*)baud_2400,  	ID_2400};

#define ID_NO_PROTOCOL		1
#define ID_NETO_PROTOCOL	2

const char protocol_no[]  	= "No Protocol";
const char protocol_neto[]  = "NetO Protocol";

const struct smenus protocolm[] = { (char*)back_string,	-1,
								(char*)protocol_no, 	ID_NO_PROTOCOL,
								(char*)protocol_neto, 	ID_NETO_PROTOCOL};

const struct smenus portm[] = { (char*)back_string,	-1,
								"Cradle", COM2,
								"IrDA",   COM1,
								"Cable",  COM0 };


void barcode_menu(int *bcode)
{
	static char options[32 + 1];

	smenu((char*)"BARCODE MENU", (struct smenus*)barcodem, 15, bcode, 1);
	strcpy(options, "B0");

	if( *bcode & ID_UPC )
		strcat(options, "R1");
	if( *bcode & ID_EAN)
		strcat(options, "R4");
	if( *bcode & ID_CODE39 )
		strcat(options, "B2");
	if( *bcode & ID_CODABAR )
		strcat(options, "B3");
	if( *bcode & ID_D2OF5)
		strcat(options, "R7");
	if( *bcode & ID_I2OF5)
		strcat(options, "R8");
	if( *bcode & ID_IATA)
		strcat(options, "B4");
	if( *bcode & ID_CODE93)
		strcat(options, "B5");
	if( *bcode & ID_CODE128)
		strcat(options, "B6");
	if( *bcode & ID_MSI_PLESSEY)
		strcat(options, "B7");
	if( *bcode & ID_ADDONS)
		strcat(options, "R2R3R5R6H3"); // UPC +2 +5, EAN +2 +5, NW7 ABC CX
	if( *bcode & ID_UK_PLESSEY)
		strcat(options, "B1");
	if( *bcode & ID_TELEPEN)
		strcat(options, "B9");
	if( *bcode & ID_M2OF5)
		strcat(options, "BB");
	if( *bcode & ID_SCODE)
		strcat(options, "R9");

	systemsetting(options);
}

