/* Sending data using the kermit protocol	*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <setjmp.h>

#include "lib.h"
#include "utils.h"
#include "menu.h"

#include "irda_lib.h"
#include "main.h"
#include "sendsw.h"

#define VERSIONSUFFIX  "23063"

#define LENGTHCOMMAND	128

static char CommandBuffer[LENGTHCOMMAND];

char telnr[30]    = "ATDT0000000000000000000000000\r";
const char f_name[]     = "John\r";
const char fl_name[]    = "John Doe\r";
const char l_name[]     = "Doe\r";
const char p_pass[]     = "opticon\r";
const char filename[]	= "DATA.TXT\r";
const char filename2[]  = "DATA.TXT\0";
const char d_descript[] = "Data bestand\r";
const char r_reset[]    = "ATZ\r";  

const char first_name[] = "rst";
const char full_name[]  = "ULL Name:";
const char last_name[]  = "ast name:";
const char file_name[]  = "ile name? ";
const char correct[]    = "correct";
const char password[]   = "ssword:";
const char choice[]	  = "hoice? ";
const char descript[]   = "escription: "; 
const char procedure[]  = "rocedure...";
const char complete[]   = "FER COMPLETE";
const char isOK[]       = "K\0";

void MakeTextFile(void);

#define WINDOWS		0
#define DOS			1

int procomm_version;

void ErrorC(int com, int use_irda, int abortkey)
{
	set_font_input();
	gotoxy(0,0);
	if(use_irda)
		printf("\f\tr   IRDA ERROR      \tr");
	else if(com == COM4)
		printf("\f\tr BLUETOOTH ERROR   \tr");
	else
		printf("\f\tr     ERROR      \tr");

	printf("\n\n Error occured");
	
	comclose_main(com, use_irda, FALSE, abortkey);
		
	resetkey();
	printf("\n  Press any key");
	while(!kbhit()) idle();
	resetkey();

	setfont(LARGE_FONT,NULL);
}

void setupProcomm(void) {
	int key;
	
	putchar('\f');
	set_font_input();
	gotoxy(0,0);

	printf("\tr  PROCOMM VERSION \tr");
	
	setfont(SMALL_FONT,NULL);
	printf("\n\n Set version:\n\n DOS   Windows");
		
	setfont(LARGE_FONT,NULL);
	gotoxy(0,3);
	printf("  \tr1\tr       \tr2\tr");

	set_font_input();

	resetkey();
	while(!kbhit()) idle();

	key = getchar();
					
	if(key == Q1_KEY) {
		procomm_version = DOS;
	}
	else if(key == Q2_KEY) {
		procomm_version = WINDOWS;
	}
	
	putchar('\f');
	set_font_input();
	gotoxy(0,0);

	printf("\tr  PROCOMM VERSION \tr");
	
	if(procomm_version==DOS)
		printf("\n\n Current version:\n       DOS");
	else 
		printf("\n\n Current version:\n     Windows");
	
	set_font_input();
				
	resetkey();
	printf("\n  Press any key");
	while(!kbhit()) idle();
	resetkey();
}

int getTelephoneNumber(void) 
{
	FILE *fp;
	int key = EOF;
	int  numPos = 4;
	char numb = '0';
	
	char nrOK = FALSE;
	
	if ((fp = fopen("telefoon.txt","rb"))!=NULL)
	{	
		printf("\f");

		numPos = 4;

		if (fgets((char*) CommandBuffer, LENGTHCOMMAND, fp) != NULL) {
			
			putchar('\f');
			
			set_font_input();
			gotoxy(0,0);
			
			printf("\tr   PHONE SETUP     \tr");
						
			setfont(MEDIUM_FONT,NULL);
			printf("\nUse this\nphone number?\nTel: ");
			
			while(CommandBuffer[numPos]!='\0') {
				printf("%c",CommandBuffer[numPos]);
				++numPos;
			}

			printf("\n 1:NO        2:YES");
			
			numPos = 0;

			key = EOF;

			while ((key=getchar())==EOF)
			   idle();
						

			switch (key) {
			case TRIGGER_KEY :
			case Q2_KEY :
				while(CommandBuffer[numPos]!='\r' && CommandBuffer[numPos]!='\0') {
					telnr[numPos] = CommandBuffer[numPos];
					
					++numPos;
				}
				telnr[numPos++] = '\r';
				telnr[numPos] = '\0';

				nrOK = TRUE;
			
				fclose(fp);
				break;
			default:
				key = EOF;
				fclose(fp);
			}
		}
	}

	while(!nrOK) {

		putchar('\f');
		
		setfont(TINY_FONT,NULL);
		gotoxy(0,9);
		printf("Next  Ready  Scroll");
		
		set_font_input();
		gotoxy(0,0);

		printf("\tr   PHONE SETUP     \tr");
		
		setfont(MEDIUM_FONT,NULL);
		printf("\n\nEnter phone number\nTel: 0");

		numPos = 4;
		key = EOF;
		
		while(key!=TRIGGER_KEY && numPos!=30) {
	    
			key = EOF;

			setfont(MEDIUM_FONT,NULL);

			while ((key=getchar())==EOF)
			   idle();
			
			switch (key) {

				case DOWN_KEY:
					if(numb<'9') ++numb;
					else if(numb=='9' && numPos > 4)
						numb = '<';
					else
						numb = '0';
					gotoxy(numPos+1,3);
					putchar(numb);
					
					if(numb != '<')
					{
						setfont(TINY_FONT,NULL);
						gotoxy(0,9);
						printf("Next  Ready  Scroll");
						set_font_input();
					}
					else
					{
						setfont(TINY_FONT,NULL);
						gotoxy(0,9);
						printf("Back  Ready  Scroll");
						set_font_input();
					}

					break;
				case TRIGGER_KEY:
					gotoxy(numPos+1,3);
					putchar(numb);

					if(numb != '<')
						telnr[numPos++] = numb;

					telnr[numPos++] = '\r';
					telnr[numPos] = '\0';
					numb = '0';
					break;
				case UP_KEY:
					if(numb != '<')
					{
						gotoxy(numPos+1,3);
						putchar(numb);
						telnr[numPos++] = numb;
						numb = '0';
						gotoxy(numPos+1,3);
						putchar(numb);
						
						setfont(TINY_FONT,NULL);
						gotoxy(0,9);
						printf("Next  Ready  Scroll");
						set_font_input();
					}
					else
					{
						gotoxy(numPos+1,3);
						putchar(' ');
						telnr[numPos] = '\r';
						telnr[numPos+1] = '\0';
						--numPos;
						if(numPos>4)
							numb = '<';
						else
							numb = '0';
						gotoxy(numPos+1,3);
						putchar(numb);
						
						setfont(TINY_FONT,NULL);
						gotoxy(0,9);
						printf("Back  Ready  Scroll");
						set_font_input();
					}
					
					break;
			}
		}

		
		numPos = 4;
		
		putchar('\f');
		
		set_font_input();
		gotoxy(0,0);
		
		printf("\tr   PHONE SETUP     \tr");
					
		setfont(MEDIUM_FONT,NULL);
		printf("\nUse this\nphone number?\nTel: ");
						
		while(telnr[numPos]!='\0') {
			printf("%c",telnr[numPos]);
			++numPos;
		}

		printf("\n 1:NO        2:YES");
			
		key = EOF;

		while ((key=getchar())==EOF)
		{   idle();
		}

		printf("\n");

		resetkey();
		if(key==Q2_KEY || key==TRIGGER_KEY)
		{
			nrOK = TRUE;

			if ((fp = fopen("telefoon.txt","w"))!=NULL)
			{	
				fprintf(fp,"%s",telnr);
				fclose(fp);
			}
			else return -1;
		}	
		else 
			return -1;
	}

	return numPos;
}


/*------------------------------------------------------------------------------------------------------------------------------*/
/*Keeps waiting and reading the buffer, comparing the given string																*/
/*Returns negative integer on error, 0 on good string read																						*/
/*------------------------------------------------------------------------------------------------------------------------------*/
static char comment[300];

int checkstring_m(char *adres2, int timeout, int abort_key)
{
	unsigned char key=0;
	int LengthCounter=0, s;

	//strange things are happening with static buffers, so always clear the buffer
	for(s=0;s<300;++s) {
		comment[s] = '\0';
	}
	
	starttimer(timeout);	// After Time Out Return negative...

	resetkey();

	while(1)
	{
        s=getcom(1);

		if(s=='\0')	  //making sure InputString isn't terminated
			continue;

		if (s!=-1){
			comment[LengthCounter]=s;
			LengthCounter++;
			comment[LengthCounter] = '\0';
		}
		if (LengthCounter>=300) return -2;

		//if (strlen(adres2)==1 && adres2[0]==s) return (OK);
        if (strstr(comment, adres2)!=NULL)	{
			return (OK);
		}
		
        if (endtimer()) return(-1);

		if(kbhit()) {
			key = getchar();

			resetkey();

			if(key==abort_key) 
				break;
			
			key = 0;
		}
	} 

	if (key==abort_key) return(-3);

	return(-1);
}

int fast_hangup(int port)
{
	int c;
	
	while(getcom(1)!=-1)	//discard all data currently found at comport
		idle();
		
	putcom('+'); putcom('+'); putcom('+');
	
	for(c=0;c<55;++c)	//wait for 1,1 seconds
		delay(1);
	
	putcom('A');putcom('T');putcom('H');putcom('0');putcom('\r');putcom('\n');

	starttimer(50);
    while (!endtimer())
    {
		c = getcom(1);

		if (c == 'O') {		//OK received
			if ((c=getcom(1)) == 'K') {
				comclose(port);
				return OK;
			}	
		}
	}

    comclose(port);
	return -1;
}

int receive_string_main(char *CheckStr, int timeout, int com, int use_irda, int abortkey) 
{
	if(com!=COM1 || !use_irda)
	{
		return checkstring_m(CheckStr, timeout, abortkey); 
	}
	else
	{
		return receive_string( CheckStr, timeout, abortkey );
	}
}

int transmit_string_main( char* data, int len, int com, int use_irda, int abortkey )
{
	char* ptr;
	int i;

	if(com!=COM1 || !use_irda)
	{
		ptr = data;
		i=0;
		while(*ptr != '\0' && i++<len)
		{
			putcom(*ptr);
			ptr++;
		}
		return 0;
	}
	else
	{
		return transmit_string_ir( data, len, abortkey );
	}
}

int delay_main(int d, int com, int use_irda, int abortkey)
{
	int ret;

	if(com==COM1 && use_irda)
		ret = Delay(d, abortkey); 
	else
	{
		starttimer(d);
		resetkey();
		while(!endtimer() && !kbhit())
			idle();
		resetkey();
		ret = 0;
	}
	return ret;
}

int putcom_main(char c, int com, int use_irda, int abortkey)
{
	int ret;

	printf("\n");
	if(com==COM1 && use_irda)
		return put_comF(c, abortkey); 
	else
	{
		printf("%c",c);
		putcom(c);
		return 0;
	}
}

int getcom_main(int timeout, int com, int use_irda, int abortkey)
{
	if(com!=COM1 || !use_irda)
	{
		return getcom(timeout);
	}
	else
	{
		return get_comF(timeout, abortkey);
	}
}

int comclose_main(int com, int use_irda, int use_phone, int abortkey)
{
	if(!use_irda)
	{	
		if(use_phone)
			fast_hangup( com);
		else
			comclose( com );
	}
	else 
		com_close( com, abortkey );

	return 0;
}

static char temp[30 + 1];
int dialup(int com, int use_irda, int num_length, int abortkey)
{
	setfont(MEDIUM_FONT,NULL);

	autopowerdown( OFF, 0 );
		
	if(delay_main(50, com, use_irda, abortkey))
		return( NOT_OK );

	printf("\fWake up phone\n");
	
	if(transmit_string_main((char *)("ATZ\r"), 4, com, use_irda, abortkey))
		return( NOT_OK );

	memset(temp, '\0', sizeof(temp));
	strcpy(temp, "OK");
	
	if (receive_string_main(temp, 500, com, use_irda, abortkey) != 0) 
	{
		printf("\fERROR:\nNo answer from\nPHONE !!!\n  press a key");
				
		comclose_main(com, use_irda, FALSE, abortkey);

		while (!kbhit())
			idle();
		resetkey();
		return( NOT_OK );
	}
	
	if(transmit_string_main((char *)telnr,num_length, com, use_irda, abortkey))
		return( NOT_OK );

	printf("Calling %s\n",telnr+4);

	return( OK );
}

int send_kermit(int com, int use_irda, int abortkey) 
{
	int num_length;

	setfont(SMALL_FONT,NULL);
	resetkey();

	if( (num_length = getTelephoneNumber())==-1 ) {
		return -1;
	}

	setupProcomm();

	if(com==COM1 && use_irda)
	{
		printf("\fInit irDa...\n");
	
		if(com_open(1, abortkey)) {
			ErrorC(com, use_irda, abortkey);
			return( NOT_OK);
		}
	}
	else
	{
		if(com==COM4)
			printf("\fInit Bluetooth\n");

		if( comopen(com) != 0) 
		{
			errbeep();
			printf("\nError while\nopening COM port!");				
			return( NOT_OK );
		}
	}
	
	if(dialup(com, use_irda, num_length, abortkey)!=OK)
	{
		return -1;
	}
	
	delay_main(500, com, use_irda, abortkey);
	printf("Waiting for reply...\n");
	
	//  procomm for windows	
	if(procomm_version==WINDOWS)
	{
		if(receive_string_main((char *)full_name, 1250, com, use_irda, abortkey)) {
			ErrorC(com, use_irda, abortkey);
			return -1;
		}
		printf("Full name: ");

		transmit_string_main((char *)fl_name,9, com, use_irda, abortkey);
		printf("John Doe\n");
	}
	else 
	{
		if(receive_string_main((char *)first_name, 1250, com, use_irda, abortkey)) {
			ErrorC(com, use_irda, abortkey);
			return -1;
		}

		printf("First name: ");
		transmit_string_main((char *)f_name,5, com, use_irda, abortkey);
		printf("John\n");
	
		if(receive_string_main((char *)last_name,250, com, use_irda, abortkey)) {
			ErrorC(com, use_irda, abortkey);
			return -1;
		}

		printf("Last name: ");
		transmit_string_main((char *)l_name,4, com, use_irda, abortkey);
		printf("Doe\n");
	}

	if(receive_string_main((char *)correct,500, com, use_irda, abortkey)) {
		ErrorC(com, use_irda, abortkey);
		return -1;
	}
	printf("Is this correct: ");
	putcom_main('Y', com, use_irda, abortkey);
	printf("Yes\n");
	
	if(receive_string_main((char *)password,500, com, use_irda, abortkey)) {
		ErrorC(com, use_irda, abortkey);
		return -1;
	}
	printf("Password: ");
	transmit_string_main((char *)p_pass,8, com, use_irda, abortkey);
	printf("*******\n");
	
	delay_main(150, com, use_irda, abortkey);

	if(receive_string_main((char *)choice,500, com, use_irda, abortkey)) {
		ErrorC(com, use_irda, abortkey);
		return -1;
	}
	printf("Enter choice: ");
	putcom_main('U', com, use_irda, abortkey);
	printf("Upload\n");
		
	delay_main(150, com, use_irda, abortkey);

	if(procomm_version!=WINDOWS)
	{
		if(receive_string_main((char *)choice,500, com, use_irda, abortkey)) {
			ErrorC(com, use_irda, abortkey);
			return -1;
		}
	}
	
	printf("Enter choice: ");
	putcom_main('K', com, use_irda, abortkey);
	printf("Kermit\n");

	delay_main(50, com, use_irda, abortkey);

//	procomm for windos	
	if(procomm_version==WINDOWS)
	{
		transmit_string_main((char *)filename,9, com, use_irda, abortkey);
		printf("File name: 'DATA.TXT'\n");

		delay_main(100, com, use_irda, abortkey);
	}
	else // procomm for dos	
	{
		if(receive_string_main((char *)file_name,500, com, use_irda, abortkey)) {
			ErrorC(com, use_irda, abortkey);
			return -1;
		}
		transmit_string_main((char *)filename,9, com, use_irda, abortkey);
		printf("File name: 'DATA.TXT'\n");

		if(receive_string_main((char *)descript,500, com, use_irda, abortkey)) {
			ErrorC(com, use_irda, abortkey);
			return -1;
		}
		printf("Description:\n");
		transmit_string_main((char *)d_descript,18, com, use_irda, abortkey);
		printf("'Demo test bestand'\n");
	
		receive_string_main((char *)procedure,1200, com, use_irda, abortkey);
	
		printf("Init file transfer\n");
	
		delay_main(50, com, use_irda, abortkey);
	}

	//filename[8] = '\0';
	printf("Transferring file...\n");
	sendsw((char *)filename2, com, use_irda, abortkey);
		
	if(receive_string_main((char *)complete,500, com, use_irda, abortkey)) {
		ErrorC(com, use_irda, abortkey);
		return -1;
	}
	printf("Transfer complete\n");

	if(procomm_version!=WINDOWS)
	{
	    if(receive_string_main((char *)choice,500, com, use_irda, abortkey)) {
			ErrorC(com, use_irda, abortkey);
			return -1;
		}
	}
	else delay_main(200, com, use_irda, abortkey);

	
	printf("Enter choice: ");
		
	putcom_main('G', com, use_irda, abortkey);
	printf("Goodbye\n");	

	delay_main(250, com, use_irda, abortkey);
	
	comclose_main(com, use_irda, FALSE, abortkey);

	setfont(LARGE_FONT,NULL);

	return 0;

}

void send_irda_mobile_GSM_kermit(void)
{
	MakeTextFile();
	systemsetting("K6"); //9600bps
	send_kermit(COM1, TRUE, TRIGGER_KEY); 
}

void versions(void);


void set_font_menu( void )
{
	setfont( LARGE_FONT, NULL );
	cursor( NOWRAP );
	cursor( OFF );
}

void set_font_input( void )
{
	setfont( MEDIUM_FONT, NULL ); 
	
	cursor( NOWRAP );
	cursor( OFF );
}

void versions(void) {
    static char os[8+1];

	printf("\fLib Version:\n%s\n",irda_lib_version());
	printf("App Version:");
	version_os(os);
	os[3] = '\0';
	os[1] = 'F';
	os[2] = 'B'; //change 'C' to 'B' if OPL9724
	printf("\n%s%s", os,VERSIONSUFFIX);

	while (getchar()==EOF)
		idle();
	resetkey();
}


void set_main_menu( char* header,  struct xmenus* mnu )
{
	mnu[0].itemfunc = send_irda_mobile_GSM_kermit;
	mnu[1].itemfunc = versions;
	
	strcpy( header, " MAIN MENU  ");
	
	mnu[0].item = "1 IrDA Demo";
	mnu[1].item = "2 Version  ";
	
}

int main_menu( int *index )
{
	static char header[12+1];
	struct xmenus mainm[2];

	resetkey();
	for (;;)
	{
		set_main_menu( header, mainm );
		set_font_menu();
		xmenu( index, header, mainm, sizeof (mainm)/sizeof(struct xmenus)-1);
		if ((*index)<0)
			return( (*index) );
		mainm[(*index)].itemfunc();
	}
}

void main( void )
{
	static int mindex;
	mindex = 0;
	
	systemsetting("B0R1R4B2B3R7R8B4B5B6B7R2R3R5R6H3"); // enable all
	
	autopowerdown( ON, 9000 ); // 180 seconds on

	cursor (AUTOWRAP);

	for(;;)
	{
		main_menu( &mindex);
	}
}

/*~~~
	- Routine name: MakeTextFile
	- Called by: 	main

	- Description:	Generate a short .txt file that can be used as a test
			when transmitting data.
~~~*/
void MakeTextFile(void)
{   FILE *fp;

	if ((fp = fopen("DATA.TXT","w"))==NULL)
	{	printf("Cannot open file\n");
		delay(50);
		return;
	}
    fprintf(fp,"abcdefghijklmnopqrstuvwxyz\n");
    fprintf(fp,"ABCDEFGHIJKLMNOPQRSTUVWXYZ\n");
    fprintf(fp,"This is the text file for the IrDA test !!!\n");
    fprintf(fp,"PHL-2700 <-ir-> Nokia 7110 <- GSM/Tel. -> Procomm plus\n");
    fprintf(fp,"Using the Kermit protocol for file transfer\n");
    fprintf(fp,"Just sit back,relax and watch the show\n");
    fprintf(fp,"The story continues.... hopefully");
	fprintf(fp,"abcdefghijklmnopqrstuvwxyz\n");
    fprintf(fp,"ABCDEFGHIJKLMNOPQRSTUVWXYZ\n");
    fprintf(fp,"This is the text file for the IrDA test !!!\n");
    fprintf(fp,"PHL-2700 <-ir-> Nokia 7110 <- GSM/Tel. -> Procomm plus\n");
    fprintf(fp,"Using the Kermit protocol for file transfer\n");
    fprintf(fp,"Just sit back,relax and watch the show\n");
    fprintf(fp,"The story continues.... hopefully");
	fclose(fp);
}

