#include <stdio.h>
#include <string.h>
#include "lib.h"
#include "internet.h"	  // header file of the TCP/IP library

struct pop_config pop;	  // Declares structure which contains POP configurations
struct isp_config isp;	  // Declares structure which contains ISP configurations

void main (void)
{
	int error=0;

	setfont(SMALL_FONT, NULL);	// small font
	systemsetting ("SZ");		// COM speed set to 115200 baud
	cursor(NOWRAP);

	// 2: Display progress messages and a progress bar
	// 0: Turn off the debug status messages
	TCPIP_init(2, 0);

	// Internet Service Provider Settings
	strcpy((char *)isp.phonenumber, "0031555012345");	// change this value!
	strcpy((char *)isp.user, "user");					// change this value!
	strcpy((char *)isp.pass, "password");				// change this value!

	isp.com	= COM2;										// Connect modem to cradle
	isp.abort_key = CLR_KEY;

	// POP IP-address = 62.58.50.10
	pop.IP1 = 62;										// change this value!
	pop.IP2 = 58;										// change this value!
	pop.IP3 = 50;										// change this value!
	pop.IP4 = 10;										// change this value!

	strcpy((char *)pop.user, "ftp_user");				// change this value!
	strcpy((char *)pop.pass, "ftp_pass");				// change this value!

	strcpy((char *)pop.local_file, "data.txt");			// Store email in "data.txt"

	pop.incl_hdrs = FALSE;								// Don't include the email header in the file
	pop.delete_msg = TRUE;								// Delete message from server after mail is receiving
	pop.abort_key = CLR_KEY;

	for(;;)
	{
		printf("\nPress any key");

		resetkey();

		while(!kbhit())
			idle();

		if( (error = connect(&isp)) < 0 )				// Dial ISP server
		{
			printf("\nConnect: \nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			while(!kbhit())
				idle();

			continue;
		}

		if ( (error=getmail(&pop,POP_INIT)) < 0)		// Login at mail server and check for new messages
		{
			printf("\nPOP_INIT: \nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			while(!kbhit())
				idle();

			continue;
		}

		printf("\n\n%d MESSAGES FOUND",pop.nr_of_msgs); // Show nr. of messages on the server

		if(pop.nr_of_msgs!=0)							// If new messages found
		{
			pop.msg_number = pop.nr_of_msgs;			// Select last message from server

			if( (error = getmail(&pop, POP_GET)) < 0 )	// Get the email from the server
			{
				printf("\nPOP_GET: \nerror #%d", error);

				disconnect(&isp);						// Disconnect from ISP and hang-up

				while(!kbhit())
					idle();

				continue;
			}
		}

		if( (error = getmail(&pop, POP_QUIT)) < 0 )		// Disconnect from POP server
		{
			printf("\nPOP_QUIT: \nerror #%d", error);

			disconnect(&isp);							// Disconnect from ISP and hang-up

			while(!kbhit())
				idle();

			continue;
		}

		disconnect(&isp);								// Disconnect from ISP

		printf("\nEmail received\n");
	}
}
