/* rfidlib.h 										*/
/* prototypes and definitions for the RFID library 	*/
/* (c) 2000, 2001 Opticon Sensors Europe BV			*/

extern int rfidopen (void);
extern void rfidclose (void);
extern int rfidversion (char *buf); 
extern char *rfid_lib_version(void);
extern int rfidsetoptions (unsigned char *buf);
extern int rfid_ti_version (unsigned char *buf);
extern int rfid_ti_getblocks (unsigned char *buf, unsigned int block_start, unsigned int nblocks,  unsigned int nbytes, unsigned char *error);
extern int rfid_ti_putblock (unsigned char *buf, unsigned int block, unsigned int nbytes, unsigned char *error);
extern int rfid_ti_putandlockblock (unsigned char *buf, unsigned int block, unsigned int nbytes, unsigned char *error);
extern int rfid_ti_lockblock (unsigned int block, unsigned char *error);
extern int rfid_ti_lockstat (unsigned char *buf, unsigned int block, unsigned int nbytes, unsigned char *error);
extern int rfid_ic_getblocks(unsigned char *buf, unsigned int block_start, unsigned int nblocks); 
extern int rfid_ic_putblock (unsigned char *buf, unsigned int block);
extern int rfid_ic_putblockverified (unsigned char *buf, unsigned int block);
extern int rfid_ic_resetquietbit(void);
extern int rfid_testmode (unsigned int mode);
extern int rfid_iso_systeminfo(unsigned char *buf);
//extern int rfid_iso_getblock (unsigned char *buf, unsigned int block_start,  unsigned int nbytes, unsigned char *error);
extern int rfid_iso_getblocks (unsigned char *buf, unsigned int block_start, unsigned int nblocks,  unsigned int nbytes, unsigned char *error);
extern int rfid_iso_getblocks_fast (unsigned char *buf, unsigned int block_start, unsigned int nblocks,  unsigned int nbytes, unsigned char *error);
extern int rfid_iso_putblock (unsigned char *buf, unsigned int block, unsigned int nbytes, unsigned char *error);
//extern int rfid_iso_putblocks (unsigned char *buf, unsigned int block, unsigned int nblocks,  unsigned int nbytes, unsigned char *error);
extern int rfid_iso_putAFI (unsigned char *buf, unsigned char *error);
extern int rfid_iso_putDSFID (unsigned char *buf, unsigned char *error);
extern int rfid_iso_lockblock (unsigned int block, unsigned char *error);
extern int rfid_iso_lockAFI(unsigned char *error);
extern int rfid_iso_lockDSFID(unsigned char *error);
extern int rfid_iso_lockstats (unsigned char *buf, unsigned int block, unsigned int nblocks, unsigned char *error);
