//commands
#define CHARGE_READ_ONLY				0x05
#define READ_PAGE						0x00
#define PROGRAM_PAGE					0x01
#define LOCK_PAGE						0x02
#define SELECTIVE_READ_PAGE				0x03

//OK return values
#define	OK								0
#define LOCKED_PAGE_READ_OK				1
#define UNLOCKED_PAGE_READ_OK			2
#define READ_ONLY_OK					3	
#define READ_WRITE_OK					4
#define PAGE_PROGRAMMED_OK				5
#define PAGE_LOCKED_OK					6

//error return values
//the error return values are numbered from -1 (least fatal error) to -10 (most fatal error) 
#define NO_RESPONSE						-1
#define UNKNOWN_ERROR					-2
#define INSUFFICIENT_FIELD_STRENGTH		-3
#define NO_ID_DATA_IN_PAGE				-4
#define RESULT_NOT_RELIABLE				-5
#define LOCKED_PAGE_ADDRESS_ERROR		-6
#define UNLOCKED_PAGE_ADDRESS_ERROR		-7
#define PAGE_NOT_LOCKED					-8
#define PAGE_WAS_LOCKED					-9
#define HARDWARE_FAILURE				-10
#define READ_ONLY_ERROR					-11
#define READ_WRITE_ONLY_ERROR			-12

//Transponder types
#define READ_ONLY_TRANSPONDER			0
#define READ_WRITE_TRANSPONDER			1
#define MPT_TRANSPONDER					2
#define SAMPT_TRANSPONDER				3
#define SAMPTS_TRANSPONDER				4

extern unsigned char response;
extern unsigned char page_address;

extern unsigned char recv_data[13];

//general functions
extern int tiris_init(void);
extern int tiris_close(void);
extern char *tiris_lib_version(void);
extern void tiris_antenna_power(unsigned int mode);

//read functions
extern int tiris_charge_only_read(void);
extern int tiris_read_page(int pagenr);
extern int tiris_selective_read_page(int pagenr, unsigned char *sel_addr);

//program functions
extern int tiris_program_page(int pagenr, unsigned char *data);
extern int tiris_selective_program_page(int pagenr, unsigned char *sel_addr, unsigned char *data);
extern int tiris_program_RW(unsigned char *data);

//lock functions
extern int tiris_lock_page(int pagenr);
extern int tiris_selective_lock_page(int pagenr, unsigned char *sel_addr);
