/************************************************************************/
/* Opticon IrDa PHL-2700 test program           					    */
/* Program for testing all the functions of the IrDa protocol functions */
/* Compiler: Microtec C compiler for Melps 7700  Version 2.2            */
/************************************************************************/


/************************************************************************/
/*      Include                                                         */
/************************************************************************/
#include		<stdio.h>
#include		<stdlib.h>
#include		<string.h>
#include        <ctype.h>
#include        "lib.h"

#include        "irda_lib.h"

/************************************************************************/
/*      Define                                                          */
/************************************************************************/
#define VERSIONSUFFIX  "21985"
#define NOT_OK         -1
#define CLEAR          -1
#define SCAN            1
#define KEYS            2
#define ALPHA           8
#define NUM             16
#define FLOAT           32
#define NONE            1
#define EVEN            2
#define ODD             3

#define LENGTHCOMMAND	128

static char CommandBuffer[LENGTHCOMMAND];

//hack ronny
//#define notIrDA	1

struct xmenus {
	char *item;                 // menu item string
    void(* itemfunc)(void);     // function to be executed on selection of item
};

struct smenus {
	char *item;                 // menu item string
	int value;                  // value to be set on selection of item
};

/************************************************************************/
/*      Global                                                          */
/************************************************************************/

static int port;
static int baudrate;
static int parity;
static int stopbits;
static int databits;
static int protocol;

/************************************************************************/
/*      extern                                                          */
/************************************************************************/
/************************************************************************/
/*      Prototype                                                       */
/************************************************************************/
int xmenu(char *menu_text, struct xmenus *tab, int max);
int sel_menu(char *menu_text, struct smenus *tab, int max, int *value, int more);

int main_menu(void);
int system_menu(void);
void main(void);

void errorC(int error);

int getTelephoneNumber(void);

void IrDA_procomm_example(void);

void setupProcomm(void);

void MakeTextFile(void);

extern int sendsw(char *filename, char abort_key);

char telnr[30]      = "ATDT0000000000000000000000000\r";//235692792\r";

#define WINDOWS		0
#define DOS			1

int procomm_version;

/************************************************************************/
/* the execution function for a selection menu                          */
/************************************************************************/
int sel_menu(char *menu_text, struct smenus *tab, int max, int *value, int more)
{
	int count;
	int index;
	int selected;
	int calcu;
	int key;
	index = 0;
	count = 0;
	putchar('\f');				/* clear screen */
	for (;;) {
		gotoxy(0, 0);
		if (index == 0)
			printf(" %s%c", menu_text, 31);
		else if (index == max)
			printf("%c%s ", 30, menu_text);
		else
			printf("%c%s%c", 30, menu_text, 31);
		if (index > 2)
			calcu = index - 2;
		else
			calcu = 0;
		for (count = 0; count<3; count++) {
			selected = (more && (tab[count + calcu].value & (*value))) ||
				(!more && (tab[count + calcu].value == (*value)));
			gotoxy(0, count + 1);
			if (index == (count + calcu))
				printf("\tr%c%s\tr", selected ? '*' : ' ', tab[count + calcu].item);
			else
			    if ((count+calcu)>max)
					printf("              ");
                else
                	printf("%c%s", selected ? '*' : ' ', tab[count + calcu].item);

		}
		while ((key=getchar())==EOF)
		{   if (powereddown())
				backlight(OFF);
			idle();
		}

		switch (key) {

#ifndef	PHL1000	
		case BL_KEY:
		case F4_KEY:
			backlight(TOGGLE);
			break;

		case UP_KEY:
		case LEFT_KEY:
		case F5_KEY:
		case F7_KEY:
#endif
		case Q1_KEY:
			if (index > 0)
				index--;
			else
				sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
			break;

#ifndef	PHL1000	
		case DOWN_KEY:
		case RIGHT_KEY:
		case F8_KEY:
		case F6_KEY:
		case Q2_KEY:
			if (index < max)
				index++;
			else
				sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
			break;
#endif
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':

			if ((key - '1') <= max) {
				if (more)
					(*value) ^= tab[(key - '1')].value;
				else {
					(*value) = tab[(key - '1')].value;
					return (key - 1);
				}
			} else
				sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
			break;

		case ESC:
			return (-1);
		case ENT_KEY:
		case TRIGGER_KEY:
			if (more)
				(*value) ^= tab[index].value;
			else {
				(*value) = tab[index].value;
				return (index);
			}

		default:
			sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
			break;
		}
	}
}

/************************************************************************/
/* the execution function for an action menu                            */
/************************************************************************/
int xmenu(char *menu_text, struct xmenus *tab, int max)
{
	int count;
	int index;
	int calcu;
	int key;
	index = 0;
	count = 0;
	putchar('\f');				/* clear screen */
	for (;;) {
		gotoxy(0, 0);
		if (index == 0)
			printf(" %s%c", menu_text, 31);
		else if (index == max)
			printf("%c%s ", 30, menu_text);
		else
			printf("%c%s%c", 30, menu_text, 31);
		if (index > 2)
			calcu = index - 2;
		else
			calcu = 0;
		for (count = 0; count < 3; count++) {
			gotoxy(0, count + 1);
			if (index == (count + calcu))
				printf("\tr%s\tr", tab[count + calcu].item);
			else
                if ((count+calcu)>max)
                    printf("              ");
                else            
				    printf("%s", tab[count + calcu].item);
		}

		while ((key=getchar())==EOF)
		{   if (powereddown())
				backlight(OFF);
			idle();
		}

		switch (key) {

#ifndef	PHL1000	
		case BL_KEY:
		case F4_KEY:
			backlight(TOGGLE);
			break;

		case UP_KEY:
		case LEFT_KEY:
		case F7_KEY:
		case F5_KEY:
#endif
		case Q1_KEY:
			if (index > 0)
				index--;
			else
				sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
			break;

#ifndef	PHL1000	
		case DOWN_KEY:
		case RIGHT_KEY:
		case F8_KEY:
		case F6_KEY:
#endif
		case Q2_KEY:
			if (index < max)
				index++;
			else
				sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
			break;


		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			if ((key - '1') <= max)
				return (key - '1');
			sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
			break;

		case ESC:
			return (-1);
		case ENT_KEY:
		case TRIGGER_KEY:
			return (index);

		default:
			sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
			break;
		}
	}
}


/************************************************************************/
/* prototypes for menu item functions                                   */
/************************************************************************/
void general_xmenu(void);
void versions(void);

/************************************************************************/
/* Menu functions                                                       */
/* There are 2 types of menus: action menus and selection menus.        */
/* The names of action menus end on _xmenu, selection menus on _smenu.  */
/* Action menus have items that are executed when selected. These items */
/* can be submenus or actions such as "Read Tags"                       */
/* Selection menus have items that present a mutually exclusive choice. */
/* The structure of the menus is defined by a header, the menu item     */
/* strings, the menu action function names (for an xmenu), and the name */
/* and possible values of a variable (for an smenu).                    */
/* These are all defined together in the upper part of the functions    */
/* so the menu structure can be easily modified.                        */
/* For example, a submenu can be added by copying an _xmenu or _smenu   */
/* function, changing its name and the menu definitions, and adding its */
/* item string and the function name to the menu table in another xmenu.*/
/************************************************************************/
void main_xmenu(void)
{
    static char myheader[]="  MAIN MENU  ";
	static struct xmenus mymenu[] =
	{
		"1 IrDa        ", general_xmenu,
		"2 Version	   ", versions
	};
    // ### edit the above lines to define the menu ###
    
    int i;
    for (;;)
    {
        i=xmenu(myheader, mymenu, sizeof (mymenu)/sizeof(struct xmenus)-1);
        if (i<0)
            return;
        mymenu[i].itemfunc();
    }
}


void general_xmenu(void)
{
    static char myheader[]=" GENERAL     ";
	static struct xmenus mymenu[] =
	{
		"1 IrDA Connect		", IrDA_procomm_example, 
		"2 Setup Procomm	", setupProcomm
	};
    // ### edit the above lines to define the menu ###

    int i;
    for (;;)
    {
        i=xmenu(myheader, mymenu, sizeof (mymenu)/sizeof(struct xmenus)-1);
        if (i<0)
            return;    
        mymenu[i].itemfunc();
    }
}

void versions(void) {
    static char os[8+1];

	printf("\fLib Version:\n%s\n",irda_lib_version());
	printf("App Version:");
	version_os(os);
	os[3] = '\0';
	os[1] = 'F';
	printf("\n%s%s", os,VERSIONSUFFIX);

	while (getchar()==EOF)
	{	if (powereddown())
			backlight(OFF);
		idle();
	}
	resetkey();
}

void setupProcomm(void) {
	int key;
	
	printf("\fSet version:\n1:DOS 2:Windows\n->");

	resetkey();
	while(!kbhit()) idle();

	key = getchar();
					
	if(key == Q1_KEY || key == '1') {
		procomm_version = DOS;
	}
	else if(key == Q2_KEY || key == '2') {
		procomm_version = WINDOWS;
	}
	else {
		if(procomm_version==DOS)
			printf("\ncurrent: DOS");
		else 
			printf("\ncurrent: Windows");
		resetkey();
		while(!kbhit()) idle();
		resetkey();
	}
}


/************************************************************************/
/* Actual test functions that are called from the menus                 */
/************************************************************************/

// general wait-key function
void wait_key(void)
{
    printf("press any key...");
    while (getchar()==EOF)
	{   if (powereddown())
			backlight(OFF);
		idle();
	}
}

void ErrorC(int error) {
	printf("\nError %d occured",error);
	Delay(50, CLR_KEY);
	com_close(1, CLR_KEY);
	setfont(LARGE_FONT,NULL);
}

int getTelephoneNumber(void) {
	FILE *fp;
	int key = EOF;
	int  numPos = 4;
	
	char nrOK = FALSE;

	if ((fp = fopen("telefoon.txt","rb"))!=NULL)
	{	
		printf("\f");

		numPos = 4;

		if (fgets((char*) CommandBuffer, LENGTHCOMMAND, fp) != NULL) {
			
			printf("Is this telephone\nnumber correct?\nTel: ");
			
			while(CommandBuffer[numPos]!='\0') {
				printf("%c",CommandBuffer[numPos]);
				++numPos;
			}

			numPos = 0;

			printf("\nPress Trigger to accept.");

			key = EOF;

			while ((key=getchar())==EOF)
			{   idle();
			}

			printf("\n");
			if(key==TRIGGER_KEY) {
				while(CommandBuffer[numPos]!='\r' && CommandBuffer[numPos]!='\0') {
					telnr[numPos] = CommandBuffer[numPos];
					
					++numPos;
				}
				telnr[numPos++] = '\r';
				telnr[numPos] = '\0';

				nrOK = TRUE;
			}
			fclose(fp);
		}
	}

	while(!nrOK) {

		printf("\fEnter telephone number\nTel:");

		numPos = 4;

		while(key!=ENT_KEY && key!=TRIGGER_KEY) {
			
			key = EOF;

			while ((key=getchar())==EOF)
			{   if (powereddown())
					backlight(OFF);
				idle();
			}
	
			switch (key) {
	
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
					telnr[numPos++] = (char)key;
					printf("%c",(char)key);
					sound(TSTANDARD, VHIGH, SMEDIUM, NULL);
					break;
				case ESC:
					return -1;
			}
		}

		telnr[numPos++] = '\r';
		telnr[numPos] = '\0';

		printf("\nIs this telephone\nnumber correct?");
			
		printf("\nPress Trigger to accept");

		key = EOF;

		while ((key=getchar())==EOF)
		{   idle();
		}

		printf("\n");

		if(key==TRIGGER_KEY) {
			nrOK = TRUE;

			if ((fp = fopen("telefoon.txt","w"))!=NULL)
			{	
				fprintf(fp,"%s",telnr);
				fclose(fp);
			}
			else return -1;
		}			

	}
	return numPos;
}

void IrDA_procomm_example(void) {
	char f_name[]     = "John\r";
	char fl_name[]    = "John Doe\r";
	char l_name[]     = "Doe\r";
	char p_pass[]     = "opticon\r";
	char filename[]	  = "DEMO.TXT\r";
	char d_descript[] = "Demo test bestand\r";
	char r_reset[]    = "ATZ\r";  

	char first_name[] = "rst";
	char full_name[]  = "ULL Name:";
	char last_name[]  = "ast name:";
	char file_name[]  = "ile name? ";
	char correct[]    = "correct";
	char password[]   = "ssword:";
	char choice[]	  = "hoice? ";
	char descript[]   = "escription: "; 
    char procedure[]  = "rocedure...";
	char complete[]   = "FER COMPLETE";
	char isOK[]       = "K\0";
	
	int num_length, error;

	MakeTextFile();

#ifdef PHL2700	
	setfont(MEDIUM_FONT,NULL);
#else 
	setfont(SMALL_FONT,NULL);
#endif

	if( (num_length = getTelephoneNumber())==-1 ) 
		return;
	
	printf("\fInit irDa...\n");
	if((error = com_open(1, CLR_KEY))) 
		goto error_label;
	
	if((error = Delay(50, CLR_KEY)))
		goto error_label;

	transmit_string_ir(r_reset,4, CLR_KEY);

	if((error = receive_string(isOK, 250, CLR_KEY))) 
		goto error_label;

	printf("Calling %s\n",telnr+4);
	transmit_string_ir(telnr,num_length, CLR_KEY);

	if((error = Delay(500, CLR_KEY)))
		goto error_label;\

	printf("Waiting for reply...\n");
	
	//  procomm for windows	
	if(procomm_version==WINDOWS)
	{
		if((error = receive_string(full_name, 2000, CLR_KEY))) 
			goto error_label;

		printf("Full name: ");
		transmit_string_ir(fl_name,9, CLR_KEY);
		printf("John Doe\n");
	}
	else 
	{
		if((error = receive_string(first_name, 1250, CLR_KEY))) 
			goto error_label;

		printf("First name: ");
		transmit_string_ir(f_name,5, CLR_KEY);
		printf("John\n");
	
		if((error = receive_string(last_name,250, CLR_KEY))) 
			goto error_label;

		printf("Last name: ");
		transmit_string_ir(l_name,4, CLR_KEY);
		printf("Doe\n");
	}

	if((error = receive_string(correct,500, CLR_KEY))) 
		goto error_label;

	printf("Is this correct: ");
	put_comF('Y', CLR_KEY);
	printf("Yes\n");
	
	if((error = receive_string(password,500, CLR_KEY))) 
		goto error_label;

	printf("Password: ");
	transmit_string_ir(p_pass,8, CLR_KEY);
	printf("*******\n");
	
	if((error = Delay(150, CLR_KEY)))
		goto error_label;

	if((error = receive_string(choice,500, CLR_KEY))) 
		goto error_label;

	printf("Enter choice: ");
	put_comF('U', CLR_KEY);
	printf("Upload\n");
		
	if((error = Delay(150, CLR_KEY)))
		goto error_label;

	if(procomm_version!=WINDOWS && (error = receive_string(choice,500, CLR_KEY)))
		goto error_label;
		
	printf("Enter choice: ");
	put_comF('K', CLR_KEY);
	printf("Kermit\n");

	if((error = Delay(50, CLR_KEY)))
		goto error_label;

//	procomm for windos	
	if(procomm_version==WINDOWS)
	{
		transmit_string_ir(filename,10, CLR_KEY);
		printf("File name: 'DEMO.TXT'\n");

		if((error = Delay(100, CLR_KEY)))
			goto error_label;
	}
	else // procomm for dos	
	{
		if((error = receive_string(file_name,500, CLR_KEY))) 
			goto error_label;

		transmit_string_ir(filename,10, CLR_KEY);
		printf("File name: 'DEMO.TXT'\n");

		if((error = receive_string(descript,500, CLR_KEY))) 
			goto error_label;

		printf("Description:\n");
		transmit_string_ir(d_descript,18, CLR_KEY);
		printf("'Demo test bestand'\n");
	
		if((error = receive_string(procedure,1200, CLR_KEY)))
			goto error_label;
	
		printf("Init file transfer\n");
	
		if((error = Delay(50, CLR_KEY)))
			goto error_label;
	}
	
	filename[8] = '\0';
	printf("Transferring file...\n");
	
	if((error = sendsw(filename, CLR_KEY)))
		goto error_label;
		
	if((error = receive_string(complete,500, CLR_KEY))) 
		goto error_label;

	printf("Transfer complete\n");

	if(procomm_version!=WINDOWS && (error = receive_string(choice,500, CLR_KEY)))
		goto error_label;
	else if((error = Delay(200, CLR_KEY)))
		goto error_label;
	
	printf("Enter choice: ");
		
	put_comF('G', CLR_KEY);
	printf("Goodbye\n");	

	if((error = Delay(250, CLR_KEY)))
		goto error_label;
	
	com_close(1, CLR_KEY);

	setfont(LARGE_FONT,NULL);

	return;

error_label:
	ErrorC(error);
	return;
}

void main(void)
{
	procomm_version = WINDOWS;

	cursor (AUTOWRAP);
	for (;;) 
        main_xmenu();
}

/*~~~
	- Routine name: MakeTextFile
	- Called by: 	main

	- Description:	Generate a short .txt file that can be used as a test
			when transmitting data.
~~~*/
void MakeTextFile(void)
{   FILE *fp;

	if ((fp = fopen("demo.txt","w"))==NULL)
	{	printf("Cannot open file\n");
		wait_key();
		return;
	}
    fprintf(fp,"abcdefghijklmnopqrstuvwxyz\n");
    fprintf(fp,"ABCDEFGHIJKLMNOPQRSTUVWXYZ\n");
    fprintf(fp,"This is the text file for the IrDA test !!!\n");
    fprintf(fp,"PHL-2700 <-ir-> Nokia 7110 <- GSM/Tel. -> Procomm plus\n");
    fprintf(fp,"Using the Kermit protocol for file transfer\n");
    fprintf(fp,"Just sit back,relax and watch the show\n");
    fprintf(fp,"The story continues.... hopefully");
	fprintf(fp,"abcdefghijklmnopqrstuvwxyz\n");
    fprintf(fp,"ABCDEFGHIJKLMNOPQRSTUVWXYZ\n");
    fprintf(fp,"This is the text file for the IrDA test !!!\n");
    fprintf(fp,"PHL-2700 <-ir-> Nokia 7110 <- GSM/Tel. -> Procomm plus\n");
    fprintf(fp,"Using the Kermit protocol for file transfer\n");
    fprintf(fp,"Just sit back,relax and watch the show\n");
    fprintf(fp,"The story continues.... hopefully");
	fclose(fp);
}


