
#ifndef __UTILS_H
#define __UTILS_H

// special defines for the battery status 
#define BATT_EMPTY			3500
#define BATT_LOW			3650
#define BATT_CHARGE_LOW		4000

#define BCR_MAX  			2700 

#define XL                    0
#define XR                  111
#define Y0                    0
#define Y1                   15
#define Y2                   31
#define Y3                   47
#define Y4                   63

#define SCAN                  1
#define KEYS                  2
#define ALPHA                 8
#define NUM                  16
#define FLOAT                32
#define NEGATIVE			 64
#define PRINT				 128
#define NOT_OK               -1
#define CLEAR                -1
#define CRADLE               20
#define POWERDOWN            30
#define KBHIT                40

#define DEFAULT			0x200 	// default return value
#define KEYBOARD		0x400	// used when input is done by keyboard
#define SCANNED			0x800	// used when input is scanned


// days of the week 
//static char day[][9+1] = {"Zondag", "Maandag", "Dinsdag", "Woensdag", "Donderdag", "Vrijdag", "Zaterdag" };
//static char day[][9+1] = {"Sunday", "Monday", "Tuesday", "Wensday", "Thursday", "Friday", "Saturday" };

void info_sound( void );
void keybeep(void);
void keybeeplow(void);
void errkeybeep(void);
void okbeep(void);
void errbeep(void);
int waitkey(void);
void is_on_cradle( void );
void check_batt_empty( void ); // check the battery 
int waitkey_no_charge( void );

void rectangle(int x1,int y1,int x2,int y2,int color);
void rectangle3d(int x1,int y1,int x2,int y2,int color);
void rectangle3drev(int x1,int y1,int x2,int y2,int color);
void draw_bar( int x_pos, int y_pos, int width, int height, int color );

// input functions 
int ScanBarcode( char* string, int min_length, int max_length);
int composite_post_processing(struct barcode *code, struct barcode *prev_code, unsigned long *time_out_value, short reset_time);
int ScanOrKeyboardInput( char* string, int min_length, int max_length, int typ, int x, int y, int offset );
int KeyboardQuantity( char* string, int max_length, int typ, int x, int y, int offset, long def_val, int max_x_d, int rect, int num, ... );

// returns the day of the week 0 is sunday, 1 is monday etc..
int what_day_of_week( void );

// display a 32*32 bit font icon 
void display_icon( int x, int y, int state );

void show_empty_batt_msg( int empty );

#endif // __UTILS_H 

