
/* drawline()   */

#include <stdio.h>
#include "lib.h"

#ifndef INVERT
#define INVERT	2
#endif

#ifndef DISP_WIDTH
#if PHL        // PHL1700-10 and PHL1700-20
   #define DISP_WIDTH  96
   #define DISP_HEIGHT 48
#elif PHL1000  // PHL1300
   #define DISP_WIDTH  96
   #define DISP_HEIGHT 64 // Change height to 48 when indicators need to be on (see cursor() function)
#elif PHL2700  // PHL2700
   #define DISP_WIDTH  128
   #define DISP_HEIGHT 64
#elif OPH      // OPH100x
   #define DISP_WIDTH  112
   #define DISP_HEIGHT 128
#else          // OPL97XX and DCL153x series
   #define DISP_WIDTH  112
   #define DISP_HEIGHT 64
#endif
#endif

void main(void)
{	
	const int modes[] = { ON, OFF, INVERT };

	int x, y, m = 0;
	int cx, cy;

	cx = DISP_WIDTH/2 - 1;
	cy = DISP_HEIGHT/2 - 1;

	for(;;)
	{
		for( x=0; x < DISP_WIDTH; x++)
            drawline( x, 0, cx, cy, modes[m]);

        for( y=0; y < DISP_HEIGHT; y++)
            drawline( DISP_WIDTH-1, y, cx, cy, modes[m]);

        for( x=DISP_WIDTH-1; x >= 0; x--)
            drawline( x, DISP_HEIGHT-1, cx, cy, modes[m]);

        for( y=DISP_HEIGHT-1; y >= 0; y--)
            drawline( 0, y, cx, cy, modes[m]);
		
		m = (m+1) % 3;
    }
}
