/* blt_discovery example */

#include "lib.h"
#include <stdio.h>
#include <string.h>



void main( void )
{
	int x, ret;
	
	// make sure this array can contain 10 objects
	// bluetooth discovery can discover 10 bluetooth items
	static device_info blt_dev_info[ 10 ];
	
	cursor( NOWRAP );
	setfont( MEDIUM_FONT, NULL );
	for(;;)
	{
		memset( blt_dev_info, '\0', sizeof( blt_dev_info ));
	    printf("\f\tr   BT Discovery    \tr\n" );
	    gotoxy( 0, 4 );
	    printf(  "\tr                   \tr");
	
	    gotoxy(0,1);
		printf("Searching..         ");

		// Do a discovery with the Trigger key to abort
    	if((ret = blt_discovery( blt_dev_info, TRIGGER_KEY)) <= 0)
    	{
	        gotoxy(0,2);
	        if( ret == 0 )
	        	printf("No device found!!!\nPress any key");
	        else if(	ret == ERR_USER_BREAK )
	        	printf("Abort key pressed\nPress any key");
	        else
	        	printf("Discovery Failure!\nPress any key");
	        while( getchar() == EOF) 
	        	idle();

	        continue;
	    }

		x=0;
		for(;;)
		{
			printf("\f\trSelect address %i/%i\tr\n",x+1,ret);
	    	gotoxy( 0, 4 );
	    	printf(  "\tr1=up        2=down \tr");
			gotoxy(0,1);
			printf("%s        \n",blt_dev_info[x].bd_address);
			printf("%s        \n",blt_dev_info[x].name);
	
			resetkey();
			while( !kbhit() )
				idle();
			switch(getchar())
			{
				case UP_KEY:
					x++;
					if (x==ret)
						x=0;
					break;
				case DOWN_KEY:
					if (x==0)
						x=ret-1;
					else
						x--;
					break;
				case TRIGGER_KEY:
					ret = TRIGGER_KEY;
					break;
			}
			if( ret == TRIGGER_KEY )
				break;
		}	
	}	
}

