
/* blt_is_connected() */

#include "lib.h"
#include <stdio.h>

void main( void )
{
	int ch, connected = FALSE;

	// To do: Make sure the Bluetooth address is configured using SetBltAddress
	// (The easiest way to configure a Bluetooth is by using barcodes)

    comopen( COM3 );			// SPP connection port

	systemsetting("WK");		// Key click sound enabled
	
	autopowerdown(ON, 60*50);	// 60 seconds
	
	goodreadled(BLUE_FLASH, -1);

    for(;;)
    {
		if(!connected && blt_is_connected())				// Succesfully connected
		{
			connected = TRUE;
			sound(TVLONG, VHIGH, SHIGH, 0);
			goodreadled(BLUE, -1);
		}
		else if(connected==TRUE && !blt_is_connected())		// Connection lost
		{
			connected = FALSE;
			sound(TVLONG, VHIGH, SLOW, 0);
			goodreadled(BLUE, 0);
			comclose( COM3 );
		}

		if((ch=getchar()) > 0)								// If key pressed
        {
			resetkey();

			if(ch == CLR_KEY)								// Manual disconnect
			{
				connected = FALSE;
				goodreadled(BLUE, 0);
				comclose( COM3 );
			}
			else if(ch == TRIGGER_KEY && !connected && comopen(-1) != COM3)	// Manual reconnect
			{
				goodreadled(BLUE_FLASH, -1);
				comopen( COM3 );
			}
		}

        idle();
    }
}
