// To use the following example the user must have access to a NetO protocol
// upload and download utility on the host. The application first tries to receive
// up to two files, and next tries to transmit the same file(s) back.
//
// The ENT key can be used to terminate the file reception/transmission.
//
// The terminal is assigned the terminal ID "123456". The terminal ID can be used to
// distinguish the terminal from other terminals in a network.

#include <stdio.h>
#include "lib.h"

void main( void )
{
#ifdef OPH                        // OPH is defined when the code is build for the OPH
    char ftest[10][16];           // Array for ten filenames; static not required for OPH
#else
    static char ftest[10][13];    // Array for ten filenames; static so space is not on stack
#endif
    int test;

    systemsetting("K7");          // 19200bps (N, 8, 1)

    for(;;)
    {
        if( comopen( COM2 ) != OK)      // COM2 is the cradle
        {
            printf("\fCan't open port");

            resetkey();
            while( !kbhit())
                idle();

            continue;
        }

        do
        {
            printf("\fReceiving..");
            test = neto_receive( ftest, "123456", ENT_KEY, 3);
            printf("\ntest=%d", test);
        } while( test < 0);

        comclose( COM2 );    // Saves power

        printf("\fresult = %d", test);
        printf("\npress any key");

        resetkey();
        while( !kbhit())
            idle();

        if( comopen( COM2 ) != OK)
        {
            resetkey();
            while( !kbhit())
                idle();

            continue;
        }

        printf("\fTransmitting...\n%d files", test);
        test = neto_transmit( ftest, test, "123456", ENT_KEY, 3);

        printf("\fresult = %d", test);
        printf("\npress any key");

        comclose( COM2 );

        resetkey();
        while( !kbhit())
            idle();
    }
}
