/************************************************************************/
/*                                                                     	*/
/*  Linker Script File													*/
/*                                                                     	*/
/************************************************************************/

MEMORY
{
	ROM (rx)  : ORIGIN = 0x1C080000, LENGTH = 0x00170000		/* Make end at 0x1CF0.0000, leaving the last 64K for non-volatile storange */
	RAM (rw)  : ORIGIN = 0x04000000, LENGTH = 0x00020000 		/* Make end at 0x0402.0000, which is the start of the file system/OS data */
}

SECTIONS 
{
	START 0x1C080000 :
	{
		*					(AP_HEAD)		  
		obj/tp_info.o		(.text .rodata*)
	} > ROM

	AP_BODY 0x1C080070 :
	{
		*					(INIT)		  
        *					(.text .rodata*)
	    *					(.glue_7)
    	*					(.glue_7t)

	} > ROM
	. = ALIGN(4);
	_code_end = . ;
 

  	.data 0x04000010 : AT (_code_end)				/* Start of data section, used for initialized data */
 	{												/* We place a copy of the data section directlty after */ 
		_data = .;									/* the end of the ROM code. We can use this to init this section after a restart */
		*					(.data)
	} > RAM
	. = ALIGN(4);
	_data_end = . ;								


	.bss :										  	/* .bss section which is used for uninitialized data */
	{												/* Variables in this section get initialized to zero upon program start */
		_bss = .;
		*					(.bss )
		*					(COMMON)
	} > RAM
	. = ALIGN(4);
	_bss_end = . ;


	STACK 0x04018000 (NOLOAD) :
  	{
		_stack = .;
    	. += 0x8000;
  	} > RAM
	_stack_end = .;
	
	_end = . ; 
}


